/*
 * Copyright (C) The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package androidvisionfacewrapper;

import anywheresoftware.b4a.AbsObjectWrapper;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.IOnActivityResult;
import anywheresoftware.b4a.BA.Permissions;

import android.content.Intent;
import android.os.Bundle;
import android.app.Activity;
import android.util.Log;
import android.view.View;
import android.widget.CompoundButton;
import android.widget.TextView;
import android.graphics.Color;

import com.google.android.gms.common.api.CommonStatusCodes;
//import com.google.android.gms.vision.barcode.Barcode;

import main.java.com.google.android.gms.samples.vision.face.facetracker.R;

import main.java.com.google.android.gms.samples.vision.face.facetracker.FaceTrackerActivity;

@ActivityObject
@ShortName("AndroidVisionFaceTracker")
//@Events(values={"scan_result(data As String, format As Int)"})
@Author("Github: Clayton Wilkinson, Wrapped by: Johan Schoeman")
@Version(1.00f)
@DependsOn(values={"android-support-v4", "android-support-v7-appcompat", "google-play-services", "android-support-design"})
@Permissions(values={"android.permission.CAMERA","android.permission.WRITE_EXTERNAL_STORAGE","android.hardware.camera","android.hardware.camera.autofocus","android.permission.VIBRATE","android.permission.FLASHLIGHT"})

public class androidVisionFaceWrapper extends AbsObjectWrapper<FaceTrackerActivity> implements View.OnClickListener {
//public class androidVisionMasterWrapper implements View.OnClickListener {
	
	@Hide
	public static BA ba;
	private String eventName;

	private static FaceTrackerActivity cv;


    // use a compound button so either checkbox or switch widgets work.
/*     private CompoundButton autoFocus;
    private CompoundButton useFlash;
    private TextView statusMessage;
    private TextView barcodeValue;
 */	
	private IOnActivityResult ion;
	
//    private static final int RC_HANDLE_GMS = 9001;
//    private static final String TAG = "BarcodeMain";
	

	
	Intent izx;
	
	public void Initialize(BA paramBA, String paramString) {
	    eventName = paramString.toLowerCase(BA.cul);
	    ba = paramBA;

	    FaceTrackerActivity cv = new FaceTrackerActivity();
	    String str = paramString.toLowerCase(BA.cul);
	
	    setObject(cv);
		izx=new Intent(BA.applicationContext, FaceTrackerActivity.class);	
		
	}	

/* 
    private void setupViews() {

        ba.activity.setContentView(BA.applicationContext.getResources().getIdentifier("activity_main", "layout", BA.packageName));

  	    String resname = "status_message";
		int resId = BA.applicationContext.getResources().getIdentifier(resname, "id", BA.packageName);
        statusMessage = (TextView) ba.activity.findViewById(resId);	
		
	    String resname1 = "barcode_value";
		int resId1 = BA.applicationContext.getResources().getIdentifier(resname1, "id", BA.packageName);
        barcodeValue = (TextView) ba.activity.findViewById(resId1);			
		
	    String resname2 = "auto_focus";
		int resId2 = BA.applicationContext.getResources().getIdentifier(resname2, "id", BA.packageName);
        autoFocus = (CompoundButton) ba.activity.findViewById(resId2);		

	    String resname3 = "use_flash";
		int resId3 = BA.applicationContext.getResources().getIdentifier(resname3, "id", BA.packageName);
        useFlash = (CompoundButton) ba.activity.findViewById(resId3);	


        int resId4 = BA.applicationContext.getResources().getIdentifier("read_barcode", "id", BA.packageName);
        ba.activity.findViewById(resId4).setOnClickListener(this);
   
    }
 */
    private static final String AutoFocus = "AutoFocus";
    private static final String UseFlash = "UseFlash";
    private static final String BarcodeObject = "Barcode";	
	
    /**
     * Called when a view has been clicked.
     *
     * @param v The view that was clicked.
     */
    @Override
    public void onClick(View v) {
        
        if (v.getId() == BA.applicationContext.getResources().getIdentifier("read_barcode", "id", BA.packageName)) {
            // launch barcode activity.
            //Intent intent = new Intent(BA.applicationContext, BarcodeCaptureActivity.class);
            //intent.putExtra("AutoFocus", true);
            //intent.putExtra("UseFlash", true);

            //ba.activity.startActivityForResult(intent, RC_BARCODE_CAPTURE);
			BeginScan();
        }

    }



     public void BeginScan() {

//        setupViews();
		    
//		if (autofocus == true) izx.putExtra("AutoFocus", true);
//		if (flashOn == true) izx.putExtra("UseFlash", true);     
        //BA.Log("autofocus = " + autofocus)	;
        //BA.Log("flashOn = " + flashOn);	

		ion=new IOnActivityResult() {
			
			@Override
			public void ResultArrived(int arg0, Intent data) {
				
				StopScan();
                if (data != null) {
/*                     Barcode barcode = data.getParcelableExtra(cv.BarcodeObject);
                    //statusMessage.setText("Barcode read successfully");
                    //barcodeValue.setText(barcode.displayValue);

					if (ba.subExists(eventName + "_scan_result")) {
                        ba.raiseEvent2(ba, false, eventName + "_scan_result", true, new Object[]{barcode.displayValue.toString(), barcode.format});
						//ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_scan_result", true, new Object[]{barcode.displayValue.toString(), barcode.format});
					}	
 */					
                    					
                } else {
					StopScan();
                    //statusMessage.setText("No barcode captured");
                    //Log.d(TAG, "No barcode captured, intent data is null");
                }

			}
		};
		ba.startActivityForResult(ion, izx);
	}
	
	
	/**
     * Stop the barcode scanner
     */		
	private void StopScan() {

        Intent intent = ba.activity.getIntent();
        ba.activity.finish();
        ba.activity.startActivity(intent);

	}	
	
/* 	
 	 private static boolean flashOn = false;
     public void setFlashOn(boolean flashOn) {
	   this.flashOn = flashOn;
	 }
	 
	 private static boolean autofocus = true;
     public void setAutoFocus(boolean autofocus) {
	   this.autofocus = autofocus;
	 }	 
 	 
	 @Hide
	 public static int[] COLOR_CHOICES = {Color.BLUE, Color.CYAN, Color.GREEN};	
     public void setTrackingColors(int[] COLOR_CHOICES) {
	   this.COLOR_CHOICES = COLOR_CHOICES;
	 }	 	 
	 
	 @Hide
	 public static float overlayTextSize = 20.0f;	
     public void setOverlayTextSize(float overlayTextSize) {
	   this.overlayTextSize = overlayTextSize;
	 }	 	 

	 @Hide
	 public static float overlayBorderWidth = 2.0f;	
     public void setOverlayBorderWidth(float overlayBorderWidth) {
	   this.overlayBorderWidth = overlayBorderWidth;
	 }	 		 
  	 
 */ 
}
